#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include "dict.h"

#define DEBUG 0 /* ǥХå 1  */
#define ANZAI 0 /* ºغjmarcfilterνϤˤȤ1*/

#define BUF_SIZE 1024
#define LABEL_LENGTH 24
#define SUBFIELD_NUM 256  /* ֥եɤο */
#define JPMARC_RS '\x1d' /* 쥳ɥѥ졼 */
#define JPMARC_FS '\x1e' /* եɥѥ졼 */
#define JPMARC_SF '\x1f' /* ֥եɼ̻Ҥκǽʸ */
#define JISC6226_ESC "\x1b\x24\x40" /* 2Хʸץ */
#define ASCII_ESC "\x1b\x28\x42" /* 1Хʸץ */
#define GAIJINUM 11 /* ο */
#define REPLACE_STR "\x21\x21" /* "" ˤʤ */
/*#define REPLACE_STR "\x22\x2e" *//* "" ˤʤ */

/* ȥ */
struct entry {
    char field[4]; /* եɼ̻ : 001, 245 ʤɡ */
    int len; /* եĹ ǡեɤĹ FSޤ */
    int addr; /* եɤƬʸΰ
	          ǡեɷƬа*/
};
/* ֥ǡե*/
struct subdatafield {
    /* ֥եɼ̻ */
    char id; /* ֥եɼʸ : A,B,D,Xʤɡ*/
    int datalen; /* ǡĹ */
    int mode; /* ǡΥ⡼ 1:ASCII or 2:JIS */
    
    /* ǡ  */
    char data[BUF_SIZE]; /* ºݤΥǡ : JP,  ʤɡ*/
};
    
/* ǡե */
struct datafield {
    int num; /* ǡեˤ륵֥ǡեɤο */
    struct subdatafield sub[SUBFIELD_NUM]; /* ֥ǡեɤ */
};

/* ǥ쥯ȥ */
struct directory {
    struct entry* e; /* ȥ */
};

/* ǡեɷ */
struct datafieldgroup {
    struct datafield* d; /* ǡե */
};

/* 쥳 */
struct record {
    int num; /* 쥳ˤ륨ȥǡեɤο */
    char label[LABEL_LENGTH+1];  /* 쥳ɥ٥ */
    struct directory dir;     /* ǥ쥯ȥ */
    struct datafieldgroup data; /* ǡեɷ */
};

void print_record (struct record rec);
char* get_datafieldgroup (char* datafieldgroup, char label[], FILE* fp);
int search (char key[], char *db[], int n);
void realchange (char str[], int len);
struct datafield get_001datafield (char datafield_str[]);
struct subdatafield get_subfield (int addr, char datafield_str[]);
struct datafield get_otherdatafield (char datafield_str[], struct entry e);
void  kanji (char str[]);
void  escape_kanji (char str[]);
int search_otergaiji (char str[]);
int get_label (char label[], FILE *fp);
void ebcdic2ascii (char label[]);
int get_length (char label[]);
char* get_dir (char* directory, int dir_lenght, FILE *fp);
int get_dirlen (char label[]); /* ǥ쥯ȥĹ֤ */
struct entry get_direntry (char* directory, int num);
struct datafield get_datafield (char* data, struct entry e);
void substr (char str1[], char str2[], int head, int len);
int get_baseaddr (char label[]);
void print_data (struct entry e, struct datafield d);
int main (int argc, char* argv[])
{
    int i;
    FILE *fp;
    char* directory;             /* ǥ쥯ȥ */
    char* datafieldgroup;        /* ǡեɷ */
    struct record rec;           /* 쥳 */
    
    if (argc < 2) {
	printf("USAGE: %s file ...\n", argv[0]);
	exit(EXIT_FAILURE);
    }
    for (i = 1; i < argc; i++) {
	/*եΥץ*/
	if ((fp = fopen(argv[i], "r")) == NULL) { 
	    perror("fopen");
	    exit(EXIT_FAILURE);
	}
	while(1) {
	     /* 쥳ɥ٥μ */
	    if (get_label(rec.label, fp) != LABEL_LENGTH) {
		/* 쥳ɥ٥μ˼Ԥ齪λ */
		break;
	    }
	    /* ǥ쥯ȥμ */
	    directory = get_dir(directory, get_dirlen(rec.label), fp);
	    
	    /* ǡեɷμ */
	    datafieldgroup = get_datafieldgroup(datafieldgroup, rec.label, fp);

	    /* 쥳ɤν */
	    rec.num = get_dirlen(rec.label) / 12;
	    rec.dir.e =  malloc(sizeof(struct entry) * rec.num);
	    rec.data.d =  malloc(sizeof(struct datafield) * rec.num);
	    
	    for (i = 0; i < rec.num; i++){
		/* ȥμ */
		rec.dir.e[i] = get_direntry(directory, i);
		/* ǡեɤμ */
		rec.data.d[i] = get_datafield(datafieldgroup, rec.dir.e[i]);
	    }
	    
	    /*  */
	    print_record(rec);
	    
	    free(rec.dir.e);
	    free(rec.data.d);
	    free(directory);
	    free(datafieldgroup);
	}
	fclose(fp);
    }
    exit(EXIT_SUCCESS);
}
/* 쥳ɤ */
void print_record (struct record rec)
{
    int i;
#if ANZAI == 0    
    /* 쥳ɥ٥ν */
    printf("%s\n\n", rec.label);
#endif
    for (i = 0; i < rec.num; i++){
    	/* ȥȥǡեɤ */
	print_data(rec.dir.e[i], rec.data.d[i]);
    }
    printf("\n");
}
/* 쥳ɥ٥ʸȤlabel˼ */
int get_label (char label[], FILE *fp)
{
    int label_length;
    label_length = fread(label, sizeof(char), LABEL_LENGTH, fp);
    label[24] = '\0';
    ebcdic2ascii(label);
    return label_length;
}

/* ǡեɷƬ֤֤
 * 쥳ɤƬΥХȿ */
int get_baseaddr (char label[])
{
    char buf[BUF_SIZE];
    substr(buf, label, 12, 5);
    return atoi(buf);   
}

/* ǥ쥯ȥĹ */
int get_dirlen (char label[])
{
    return get_baseaddr(label) - LABEL_LENGTH;
}

/* ǥ쥯ȥʸȤdirectory˼ */
char* get_dir (char* directory, int dir_length, FILE *fp)
{
    directory = malloc(sizeof(char) * dir_length);
    fread(directory, sizeof(char), dir_length, fp);
    directory[dir_length - 1] =  '\0';
    ebcdic2ascii(directory);
    return directory;
}

/* ǡեɷμ */
char* get_datafieldgroup (char* datafieldgroup, char label[], FILE* fp)
{
    int len;      /* ǡեɷĹ */

    len = get_length(label) - get_baseaddr(label);
    datafieldgroup = malloc(sizeof(char) * (len + 1));
    
    /* ǡեɷμ */
    fread(datafieldgroup, sizeof(char), len, fp);
    datafieldgroup[len] = '\0';

    return datafieldgroup;
}

/* ȥȥǡեɤ */
void print_data (struct entry e, struct datafield d)
{
    int i;
    
#if ANZAI == 0
    if (strcmp(e.field, "001") == 0) {
	printf("%s  %s\n", e.field, d.sub[0].data);
    } else {
	for( i = 0; i < d.num; i++) {
	    printf("%s $%c %s\n", e.field, d.sub[i].id, d.sub[i].data);
	}
    }
#endif
    
#if ANZAI == 1
    if (strcmp(e.field, "001") == 0) {
	printf("%s%s\n", e.field, d.sub[0].data);
    } else {
	for( i = 0; i < d.num; i++) {
	    printf("%s$%c%s\n", e.field, d.sub[i].id, d.sub[i].data);
	}
    }
#endif	    

}

 /* ǡեɤ¤ΤȤ֤ */
struct datafield get_datafield (char* datafieldgroup, struct entry e)
{
    char* datafield_str;
    struct datafield d;

    /* ǡեɤʸȤƼФ */
    datafield_str = malloc(sizeof(char) * e.len);
    substr(datafield_str, datafieldgroup, e.addr, e.len - 1);

    /* ǡեɤ¤ΤȤƼ */
    if (strcmp(e.field, "001") == 0) {
	/* 001եɤξ */
	d = get_001datafield(datafield_str);
    } else {
	/* 001եɰʳξ */
	d = get_otherdatafield(datafield_str, e);
    }
    free(datafield_str);
    return d;
}

/* 001եɤΥǡեɤμ */
struct datafield get_001datafield (char datafield_str[])
{
    struct datafield d;

    /* ֥ǡեɤο */
    d.num = 1;
    
    /* ֥եɼʸ : A,B,D,Xʤɡ   */
    /* ˥֥եɼʸϤʤΤŬ */
    d.sub[0].id = '1';
    
    /* ǡĹ */
    d.sub[0].datalen = 8;

    /* ǡΥ⡼ 1:ASCII */
    d.sub[0].mode = 1;   

    /* ºݤΥǡ : 20000001*/
    substr(d.sub[0].data, datafield_str, 0, 8);
    ebcdic2ascii(d.sub[0].data);

    return d;
}

/* 001եɰʳΥǡե
 *  = ֥ǡեɤޤǡեɡˤμ */   
struct datafield get_otherdatafield (char datafield_str[], struct entry e)
{
    int i;
    struct datafield d; /* ǡե */
     
    d.num = 0; /* ֥ǡեɤο */
    for (i =0; i < e.len; i++) {
	if (datafield_str[i] == JPMARC_SF) {
	    /* ƥ֥ǡեɤ */
	    d.sub[d.num] = get_subfield(i, datafield_str);
	    d.num++;
	}
	if(d.num > SUBFIELD_NUM -1){
	    fprintf(stderr, "ٹ𡧥֥եɤο%dۤƤޤ\n",SUBFIELD_NUM);
	    break;
	}
    }
    return d;
}

/* ֥ǡեɤμ */
struct subdatafield get_subfield (int addr, char datafield_str[])
{
    char idbuf[BUF_SIZE];
    char buf[BUF_SIZE];
    struct subdatafield s; /* ֥ǡե */

    substr(idbuf, datafield_str, addr + 1, 5);
    ebcdic2ascii(idbuf);

    /* ֥եɼʸ : A,B,D,Xʤɡ   */
    s.id = idbuf[0];

    /* ǡĹ */
    substr(buf, idbuf, 1, 3);
    s.datalen = atoi(buf);

    /* ǡΥ⡼ 1:ASCII or 2:JIS */
    substr(buf, idbuf, 4, 1);
    s.mode = atoi(buf);

    /* ǡ */
    substr(s.data, datafield_str, addr + 6, s.datalen);
    if ( s.mode == 1 ) { /* ASCIIä */
	ebcdic2ascii(s.data);
    } else if (s.mode == 2 ) { /* JISä */
	kanji(s.data);
    } else { /* ɤǤʤä鶯λ */
	printf("!!!!!! NO MODE !!!!!\n");
	exit(EXIT_FAILURE);
    }
    return s;
}

/* νۤɤ
 * JIS X 0208 򥨥ץɤޤ֤ */
void  kanji (char str[])
{
    realchange(str, strlen(str)); /* ν */
    escape_kanji(str); /* JIS X 0208 򥨥ץɤޤ */
}

/* JIS X 0208 򥨥ץɤޤ֤ */
void  escape_kanji (char str[])
{
    char buf[BUF_SIZE];
    strcpy(buf, str);
    sprintf(str, "%s%s%s", JISC6226_ESC, buf, ASCII_ESC);
}

/* str2  head  len ʸܤޤǤ str1 ˥ԡ */
void substr (char str1[], char str2[], int head, int len)
{
    strncpy(str1, str2 + head, len);
    str1[len] = '\0';
}

/* ȥ */
struct entry get_direntry (char* directory, int num)
{
    struct entry e; /* ȥ */
    int addr; /* ȥƬ */
    char entry[13], buf[BUF_SIZE];
    
    addr = 12 * num;

    substr(entry, directory, addr, 12);

    /* եɼ̻ : 001, 245 ʤɡ*/
    substr(e.field, entry, 0, 3);

    /* եĹ: ǡեɤĹ FSޤ */
    substr(buf, entry, 3, 4);
    e.len = atoi(buf);
    
    /* եɤƬʸΰ: 
       ǡեɷƬа */
    substr(buf, entry, 7, 5);
    e.addr = atoi(buf);
    
    return e;
	
}

/* 쥳Ĺ֤
 * 쥳Ĺ: 쥳ɥ٥ƬRSޤ᤿쥳ɤĹ*/
int get_length (char label[])
{
    char buf[BUF_SIZE];
    substr(buf, label, 0, 5);
    return atoi(buf);
}

static char e2a_table[] = {
    '\000', '\001', '\002', '\003', '\004', '\005', '\006', '\007', 
    '\010', '\011', '\012', '\013', '\014', '\015', '\016', '\017', 
    '\020', '\021', '\022', '\023', '\024', '\025', '\026', '\027', 
    '\030', '\031', '\032', '\033', '\034', '\035', '\036', '\037', 
    '\040', '\041', '\042', '\043', '\044', '\045', '\046', '\047', 
    '\050', '\051', '\052', '\053', '\054', '\055', '\056', '\057', 
    '\060', '\061', '\062', '\063', '\064', '\065', '\066', '\067', 
    '\070', '\071', '\072', '\073', '\074', '\075', '\076', '\077', 
    ' ',    '\101', '\102', '\103', '\104', '\105', '\106', '\107', 
    '\110', '\111', '[',    '.',    '<',    '(',    '+',    '!', 
    '&',    '\121', '\122', '\123', '\124', '\125', '\126', '\127', 
    '\130', '\131', ']',    '\\',    '*',    ')',    ';',    '^', 
    '-',    '/',    '\142', '\143', '\144', '\145', '\146', '\147', 
    '\150', '\151', '|',    ',',    '%',    '_',    '>',    '?', 
    '\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167', 
    '\170', '\'',   ':',    '#',    '@',    '`',    '=',    '"', 
    '\200', 'a',    'b',    'c',    'd',    'e',    'f',    'g', 
    'h',    'i',    '\212', '\213', '\214', '\215', '\216', '\217', 
    '\220', 'j',    'k',    'l',    'm',    'n',    'o',    'p', 
    'q',    'r',    '\232', '\233', '\234', '\235', '\236', '\237', 
    '\240', '-',    's',    't',    'u',    'v',    'x',    'w', 
    'y',    'z',    '\252', '\253', '\254', '\255', '\256', '\257', 
    '\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267', 
    '\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277', 
    '{',    'A',    'B',    'C',    'D',    'E',    'F',    'G', 
    'H',    'I',    '\312', '\313', '\314', '\315', '\316', '\317', 
    '}',    'J',    'K',    'L',    'M',    'N',    'O',    'P', 
    'Q',    'R',    '\332', '\333', '\334', '\335', '\336', '\337', 
    '$',    '\341', 'S',    'T',    'U',    'V',    'W',    'X', 
    'Y',    'Z',    '\352', '\353', '\354', '\355', '\356', '\357', 
    '0',    '1',    '2',    '3',    '4',    '5',    '6',    '7', 
    '8',    '9',    '\372', '\373', '\374', '\375', '\376', '\377' };

void ebcdic2ascii (char label[])
{
    int i, length;
    length = strlen(label);
    for (i = 0; i < length; i++) {
	label[i] = e2a_table[(unsigned char)label[i]];
    }
}

/* ˤʸ  ʸ, ¾γ  REPLACESTR ,
 * ʸ  "", ""  "Ĺ"  
 *  str[]: ץ󥹤ޤޤʤ2ХȤʸ */
void realchange (char str[], int len)
{
    extern char *dict[];
#if ANZAI == 1    
    extern char *dictout[];
#endif    
#if ANZAI == 0
    extern char *dictout2[];
    char bbuf[BUF_SIZE];
#endif    
    char buf[BUF_SIZE];
    char new[BUF_SIZE] = "";
    int i, addr;

    if ( (len % 2) != 0) {
	printf("len:%d is Ǥ\n", len);
	exit(EXIT_FAILURE);
    }
    for (i = 0; i < len; i = i + 2) {	
	strncpy(buf, str + i, 2);
	buf[i + 2] = '\0';
	addr = search(buf, dict, GAIJINUM);
	if ( addr != -1) { /* ˤ볰ν */
#if ANZAI == 1	    
	    strcat(new, dictout[addr]);
#endif	    
#if ANZAI == 0
	    strcat(new, dictout2[addr]);
	} else if( search_otergaiji(buf) != -1) {
	    /* ˤʤν */
	    strcat(new, REPLACE_STR); 
	} else if ( (buf[0] == '\x1c') &&
		    (buf[1] >= '\x4e' && buf[1] <= '\x53')) {
	    /* 楳ɤʤΤɲäʤ */
	} else if (buf[0] =='\x21' && buf[1] == '\x5d') { /* ⤷ޥʥʤ */
	    /* ޥʥĹѹ뤿ʸäƤ */
	    strncpy(bbuf, str + i - 2, 2);
	    bbuf[i] = '\0';
	    if(( bbuf[0] == '\x24' || bbuf[0] == '\x25')
	       && (bbuf[1] >= '\x21' && bbuf[1] <= '\x76')) {
		/* ⤷ʤ⤷ʿ̾ä */
		strcat(new, "\x21\x3c"); /* Ĺѹ */
	    } else {
		strcat(new, buf); /* Τޤޥޥʥ */
	    }		
#endif	    
	} else { /* ʤä餽Τޤɲ */
	    strcat(new, buf);
	}
    }
    strcpy(str, new);
}

/* ¾γ뤫Ƚ 1 ʤ-1 */
int search_otergaiji (char str[])
{
    if((str[0] >= '\x30' && str[0] <='\x7e')
       && (str[1] >= '\xa1' && str[1] <= '\xfe')) {
	return 1;
    } else if ( (str[0] >= '\x29' && str[0] <='\x2f')
		&& (str[1] >= '\x21' && str[1] <= '\x7e')) {
	return 1;
    } else if ( (str[0] == '\x22')
		&& (str[1] >= '\x2f' && str[1] <= '\x68')) {
	return 1;
    } else {
	return -1;
    }
}
    
/* key db ˤ ΰ֤֤*/
int search (char key[], char *db[], int n)
{
    int left = 0, right = n - 1, mid;
    int count = 0;
    while(left <= right) {
        count++;
        mid = (left + right) / 2;
        if (strcmp(key, db[mid]) == 0){
            return(mid);
        } else if (strcmp(key, db[mid]) < 0){
            right = mid - 1;
        } else {
            left = mid + 1;
        }
    }
    return(-1);
}
